from sokoenginepy.game import (
    BaseTessellation,
    Config,
    Direction,
    OctobanTessellation,
    PusherStep,
    Tessellation,
)

from .autogenerated_tessellation import OctobanTessellationAutogeneratedSpecMixin
from .tessellation_spec_mixin import TessellationSpecMixin


class DescribeOctobanTessellation(
    TessellationSpecMixin, OctobanTessellationAutogeneratedSpecMixin
):

    illegal_directions = []

    legal_directions = [
        Direction.LEFT,
        Direction.RIGHT,
        Direction.UP,
        Direction.DOWN,
        Direction.NORTH_WEST,
        Direction.NORTH_EAST,
        Direction.SOUTH_WEST,
        Direction.SOUTH_EAST,
    ]

    legal_moves = [
        PusherStep(Direction.LEFT, Config.NO_ID),
        PusherStep(Direction.RIGHT, Config.NO_ID),
        PusherStep(Direction.UP, Config.NO_ID),
        PusherStep(Direction.DOWN, Config.NO_ID),
        PusherStep(Direction.NORTH_WEST, Config.NO_ID),
        PusherStep(Direction.NORTH_EAST, Config.NO_ID),
        PusherStep(Direction.SOUTH_WEST, Config.NO_ID),
        PusherStep(Direction.SOUTH_EAST, Config.NO_ID),
        PusherStep(Direction.LEFT, Config.DEFAULT_ID),
        PusherStep(Direction.RIGHT, Config.DEFAULT_ID),
        PusherStep(Direction.UP, Config.DEFAULT_ID),
        PusherStep(Direction.DOWN, Config.DEFAULT_ID),
        PusherStep(Direction.NORTH_WEST, Config.DEFAULT_ID),
        PusherStep(Direction.NORTH_EAST, Config.DEFAULT_ID),
        PusherStep(Direction.SOUTH_WEST, Config.DEFAULT_ID),
        PusherStep(Direction.SOUTH_EAST, Config.DEFAULT_ID),
    ]

    legal_characters = [
        "l",
        "r",
        "u",
        "d",
        "w",
        "n",
        "s",
        "e",
        "L",
        "R",
        "U",
        "D",
        "W",
        "N",
        "S",
        "E",
    ]

    tessellation1 = OctobanTessellation()
    tessellation2 = BaseTessellation.instance(Tessellation.OCTOBAN)
