from sokoenginepy.game import (
    BaseTessellation,
    Config,
    Direction,
    PusherStep,
    SokobanTessellation,
    Tessellation,
)

from .autogenerated_tessellation import SokobanTessellationAutogeneratedSpecMixin
from .tessellation_spec_mixin import TessellationSpecMixin


class DescribeSokobanTessellation(
    TessellationSpecMixin, SokobanTessellationAutogeneratedSpecMixin
):
    illegal_directions = [
        Direction.NORTH_WEST,
        Direction.NORTH_EAST,
        Direction.SOUTH_WEST,
        Direction.SOUTH_EAST,
    ]

    legal_directions = [Direction.LEFT, Direction.RIGHT, Direction.UP, Direction.DOWN]

    legal_moves = [
        PusherStep(Direction.LEFT, Config.NO_ID),
        PusherStep(Direction.RIGHT, Config.NO_ID),
        PusherStep(Direction.UP, Config.NO_ID),
        PusherStep(Direction.DOWN, Config.NO_ID),
        PusherStep(Direction.LEFT, Config.DEFAULT_ID),
        PusherStep(Direction.RIGHT, Config.DEFAULT_ID),
        PusherStep(Direction.UP, Config.DEFAULT_ID),
        PusherStep(Direction.DOWN, Config.DEFAULT_ID),
    ]

    legal_characters = ["l", "r", "u", "d", "L", "R", "U", "D"]

    tessellation1 = SokobanTessellation()
    tessellation2 = BaseTessellation.instance(Tessellation.SOKOBAN)
