from sokoenginepy.game import (
    BaseTessellation,
    Config,
    Direction,
    PusherStep,
    Tessellation,
    TriobanTessellation,
)

from .autogenerated_tessellation import TriobanTessellationAutogeneratedSpecMixin
from .tessellation_spec_mixin import TessellationSpecMixin


class DescribeTriobanTessellation(
    TessellationSpecMixin, TriobanTessellationAutogeneratedSpecMixin
):

    illegal_directions = [Direction.UP, Direction.DOWN]

    legal_directions = [
        Direction.LEFT,
        Direction.RIGHT,
        Direction.NORTH_WEST,
        Direction.NORTH_EAST,
        Direction.SOUTH_WEST,
        Direction.SOUTH_EAST,
    ]

    legal_moves = [
        PusherStep(Direction.LEFT, Config.NO_ID),
        PusherStep(Direction.RIGHT, Config.NO_ID),
        PusherStep(Direction.NORTH_WEST, Config.NO_ID),
        PusherStep(Direction.NORTH_EAST, Config.NO_ID),
        PusherStep(Direction.SOUTH_WEST, Config.NO_ID),
        PusherStep(Direction.SOUTH_EAST, Config.NO_ID),
        PusherStep(Direction.LEFT, Config.DEFAULT_ID),
        PusherStep(Direction.RIGHT, Config.DEFAULT_ID),
        PusherStep(Direction.NORTH_WEST, Config.DEFAULT_ID),
        PusherStep(Direction.NORTH_EAST, Config.DEFAULT_ID),
        PusherStep(Direction.SOUTH_WEST, Config.DEFAULT_ID),
        PusherStep(Direction.SOUTH_EAST, Config.DEFAULT_ID),
    ]

    legal_characters = ["l", "r", "u", "n", "s", "d", "L", "R", "U", "N", "S", "D"]

    tessellation1 = TriobanTessellation()
    tessellation2 = BaseTessellation.instance(Tessellation.TRIOBAN)
